/*
  Program: Vyhodnocova sebereferennho testu
  Autor: Radek Pelnek  
  Ploha ke knize "Jak to vyeit",  www.radekpelanek.cz/?jtv

  Zadn projektu: Napite program, kter zkontroluje zda sebe-referenn test
  (viz kniha) m jednoznan een. Vstup (konkrtn kvz) me bt zakdovn
  pmo v programu. Vstupem programu je vpis vech een.
  
*/


#include <iostream>

using namespace std;

int a[11];
// Globln pole aktulnch tip. Z dvodu itelnosti pouvme indexovn od
// 1. Poloka a[0] je nevyuita.

// Pro aktuln piazen v poli "a" zkontroluje, zda je cel test v podku.
bool vyhodnot() {
  
  //1. Prvn otzka, na kterou je odpov A, je otzka
  //   (A) 4  (B) 3  (C)  2  (D)  1 (E) ani jedno z pedchozho
  if (a[1] == 1 && (a[4] != 1 || a[3] == 1 || a[2] == 1 || a[1] == 1)) return false;
  if (a[1] == 2 && (a[3] != 1 || a[2] == 1 || a[1] == 1)) return false;
  if (a[1] == 3 && (a[2] != 1 || a[1] == 1)) return false;
  if (a[1] == 4 && (a[1] != 1)) return false;
  if (a[1] == 5 && (a[2] == 1 || a[3] ==1 || a[4] == 1)) return false;

  // 2. Stejnou odpov maj otzky
  //    (A) 3 a 4  (B) 4 a 5  (C) 5 a 6   (D) 6 a 7   (E) 7 a 8
  if (a[2] == 1 && (a[3] != a[4])) return false; 
  if (a[2] == 2 && (a[4] != a[5])) return false; 
  if (a[2] == 3 && (a[5] != a[6])) return false; 
  if (a[2] == 4 && (a[6] != a[7])) return false; 
  if (a[2] == 5 && (a[7] != a[8])) return false; 

// 3. Dal otzka, na kterou je odpov A, je otzka   
//    (A) 4  (B) 5  (C) 6  (D) 7  (E) 8 
  if (a[3] == 1 && a[4] != 1) return false; 
  if (a[3] == 2 && a[5] != 1) return false; 
  if (a[3] == 3 && a[6] != 1) return false; 
  if (a[3] == 4 && a[7] != 1) return false; 
  if (a[3] == 5 && a[8] != 1) return false; 

// 4. Prvn sud otzka, na kterou je odpov B, je otzka
//    (A) 2  (B) 4  (C) 6  (D) 8  (E) 10
  if (a[4] == 1 && a[2] != 2) return false; 
  if (a[4] == 2 && (a[2] == 2 || a[4] != 2)) return false; 
  if (a[4] == 3 && (a[2] == 2 || a[4] == 2 || a[6] != 2)) return false; 
  if (a[4] == 4 && (a[2] == 2 || a[4] == 2 || a[6] == 2 || a[8] != 2)) return false; 
  if (a[4] == 5 && (a[2] == 2 || a[4] == 2 || a[6] == 2 || a[8] == 2 || a[10] != 2)) return false; 

// 5. Jedin lich otzka, na kterou je odpov C, je otzka
//    (A) 1  (B) 3  (C) 5   (D) 7  (E) 9
  if (a[5] == 1 && (a[1] != 3 || a[3] == 3 || a[5] == 3 || a[7] == 3 || a[9] == 3)) return false; 
  if (a[5] == 2 && (a[1] == 3 || a[3] != 3 || a[5] == 3 || a[7] == 3 || a[9] == 3)) return false; 
  if (a[5] == 3 && (a[1] == 3 || a[3] == 3 || a[5] != 3 || a[7] == 3 || a[9] == 3)) return false; 
  if (a[5] == 4 && (a[1] == 3 || a[3] == 3 || a[5] == 3 || a[7] != 3 || a[9] == 3)) return false; 
  if (a[5] == 5 && (a[1] == 3 || a[3] == 3 || a[5] == 3 || a[7] == 3 || a[9] != 3)) return false; 

// 6. Otzka, na kterou je odpov D   
//    (A) je ped touto, ale ne za n  (B) je za touto, ale ne ped n  (C) je
//    ped touto i za n  (D) vbec se nevyskytuje   (E) ani jedno z pedchozho 
  bool jepred = false, jezad = false;
  int i;
  for (i=1; i<=10; i++) { 
    if (a[i] == 4) {
      if (i < 6) jepred = true;
      if (i > 6) jezad = true;
    }
  }
  if (a[6] == 1 && ! (jepred && !jezad)) return false; 
  if (a[6] == 2 && ! (!jepred && jezad)) return false; 
  if (a[6] == 3 && ! (jepred && jezad)) return false; 
  if (a[6] == 4 && ! (!jepred && !jezad && a[6] !=4)) return false; 
  if (a[6] == 5 && ! (false)) return false;   

// 7. Posledn otzka, na kterou je odpov E je   
//    (A) 5  (B) 6  (C) 7   (D) 8  (E) 9 
  if (a[7] == 1 && (a[5] != 5 || a[6] == 5 || a[7] == 5 || a[8] == 5 || a[9] == 5 || a[10] == 5)) return false; 
  if (a[7] == 2 && (a[6] != 5 || a[7] == 5 || a[8] == 5 || a[9] == 5 || a[10] == 5)) return false; 
  if (a[7] == 3 && (a[7] != 5 || a[8] == 5 || a[9] == 5 || a[10] == 5)) return false; 
  if (a[7] == 4 && (a[8] != 5 || a[9] == 5 || a[10] == 5)) return false; 
  if (a[7] == 5 && (a[9] != 5 || a[10] == 5)) return false; 

// 8. Poet otzek, na kter je odpov souhlska, je   
//    (A) 7  (B) 6  (C) 5   (D) 4  (E) 3 
  int sam = 0;
  for (i=1; i<=10; i++) { if (a[i] == 1 || a[i] == 5) sam++; }
  if (a[8] == 1 && 10-sam != 7) return false; 
  if (a[8] == 2 && 10-sam != 6) return false; 
  if (a[8] == 3 && 10-sam != 5) return false; 
  if (a[8] == 4 && 10-sam != 4) return false; 
  if (a[8] == 5 && 10-sam != 3) return false; 

// 9. Poet otzek, na kter je odpov samohlska, je   
//    (A) 0  (B) 1  (C) 2   (D) 3  (E) 4
  if (a[9] == 1 && sam != 0) return false; 
  if (a[9] == 2 && sam != 1) return false; 
  if (a[9] == 3 && sam != 2) return false; 
  if (a[9] == 4 && sam != 3) return false; 
  if (a[9] == 5 && sam != 4) return false; 

// 10. Odpov na tuto otzku je   
//    (A) A  (B) B  (C) C   (D) D  (E) E
//  vzdy splneno

  return true;
}

void vypis() {
  for (int i=1; i<=10; i++) 
    cout << a[i] << " ";
  cout << endl;
}

int main() {  
  int i;
  bool done = false;
  int pocet_reseni = 0;

  for (i=1; i<=10; i++) a[i] = 1;

  // Generovn vech variant -- odpovid postupnmu pitn jedniky v ptkov soustav.
  while (!done) {
    i = 1; 
    a[i]++;
    while (a[i] > 5 && i < 10) { a[i]=1; i++; a[i]++; }
    if (a[i] > 5) { done = true; }
    else {
      if (vyhodnot()) {
	cout << "Reseni: ";
	vypis();
	pocet_reseni++;
      }
    }
  }

  cout << "Pocet reseni: " << pocet_reseni << endl;  
  return 0;
}
